<?php
/*
Plugin Name: SDAC Related Content
Plugin URI: Plugin URI: http://www.sandboxdev.com/blog-and-cms-development/wordpress/wordpress-plugins
Description: Show Related Content by Category with Caching. 
Author: Jennifer Zelazny/SDAC Inc.
Version: 2.0
Author URI: http://www.sandboxdev.com

---------------------------------------------------
Originally Based on the un-cached/no admin version:
http://playground.ebiene.de/400/related-posts-by-category-the-wordpress-plugin-for-similar-posts/ 
By Sergej M&uuml;ller
---------------------------------------------------
Released under the GPL license
http://www.opensource.org/licenses/gpl-license.php
---------------------------------------------------
This is an add-on for WordPress
http://wordpress.org/
---------------------------------------------------
This plugin is distributed  WITHOUT ANY WARRANTY; 
without even the implied warranty of 
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. 
---------------------------------------------------
*/


function sdac_related_content_menu() {
  add_options_page('Related Content Options', 'Related Content Options', 8, basename(__FILE__), 'sdac_related_content_admin_options');
}


$sdac_related_content_data = array(
	'type' => '',
	'orderby' => '',
	'order' => '',
	'limit' => '',
	'echo' => '',
	'related_title' => '',
	'before_list' => '',
	'after_list' => '',
	'before_item' => '',
	'after_item' => '',
	'inside' => '',
	'outside' => '',
	'add_to_posts' => '',
	'cache_time' => '',
	'rel' => '',
	'message' => ''
	);


add_option('sdac_related_content_options',$sdac_related_content_data,'Related Content Options Options');

$sdac_related_content_options = get_option('sdac_related_content_options');

$sdac_flash = '';


function sdac_related_content_admin_options() {
	global $sdac_flash, $sdac_related_content_options, $_POST, $wp_rewrite;
	if (isset($_POST['type']) || isset($_POST['orderby']) || isset($_POST['order']) || isset($_POST['limit']) || isset($_POST['related_title']) || isset($_POST['before_list']) || isset($_POST['after_list']) || isset($_POST['before_item']) || isset($_POST['after_item']) || isset($_POST['inside']) || isset($_POST['outside']) ||  isset($_POST['add_to_posts']) || isset($_POST['cache_time']) ||  isset($_POST['rel']) || isset($_POST['message'])) {
		
		if (isset($_POST['type'])) { 
			$sdac_related_content_options['type'] = stripslashes($_POST['type']);
			update_option('sdac_related_content_options',$sdac_related_content_options);
			$sdac_flash = "Your settings have been saved.";
		}
		if (isset($_POST['orderby'])) { 
			$sdac_related_content_options['orderby'] = stripslashes($_POST['orderby']);
			update_option('sdac_related_content_options',$sdac_related_content_options);
			$sdac_flash = "Your settings have been saved.";
		}
		if (isset($_POST['order'])) { 
			$sdac_related_content_options['order'] = stripslashes($_POST['order']);
			update_option('sdac_related_content_options',$sdac_related_content_options);
			$sdac_flash = "Your settings have been saved.";
		}
		if (isset($_POST['limit'])) { 
			$sdac_related_content_options['limit'] = stripslashes($_POST['limit']);
			update_option('sdac_related_content_options',$sdac_related_content_options);
			$sdac_flash = "Your settings have been saved.";
		}
		if (isset($_POST['echo'])) { 
			$sdac_related_content_options['echo'] = stripslashes($_POST['echo']);
			update_option('sdac_related_content_options',$sdac_related_content_options);
			$sdac_flash = "Your settings have been saved.";
		}
		if (isset($_POST['related_title'])) { 
			$sdac_related_content_options['related_title'] = stripslashes($_POST['related_title']);
			update_option('sdac_related_content_options',$sdac_related_content_options);
			$sdac_flash = "Your settings have been saved.";
		}
		if (isset($_POST['before_list'])) { 
			$sdac_related_content_options['before_list'] = stripslashes($_POST['before_list']);
			update_option('sdac_related_content_options',$sdac_related_content_options);
			$sdac_flash = "Your settings have been saved.";
		}
		if (isset($_POST['after_list'])) { 
			$sdac_related_content_options['after_list'] = stripslashes($_POST['after_list']);
			update_option('sdac_related_content_options',$sdac_related_content_options);
			$sdac_flash = "Your settings have been saved.";
		}
		if (isset($_POST['before_item'])) { 
			$sdac_related_content_options['before_item'] = stripslashes($_POST['before_item']);
			update_option('sdac_related_content_options',$sdac_related_content_options);
			$sdac_flash = "Your settings have been saved.";
		}
		if (isset($_POST['after_item'])) { 
			$sdac_related_content_options['after_item'] = stripslashes($_POST['after_item']);
			update_option('sdac_related_content_options',$sdac_related_content_options);
			$sdac_flash = "Your settings have been saved.";
		}
		if (isset($_POST['inside'])) { 
			$sdac_related_content_options['inside'] = stripslashes($_POST['inside']);
			update_option('sdac_related_content_options',$sdac_related_content_options);
			$sdac_flash = "Your settings have been saved.";
		}
		if (isset($_POST['outside'])) { 
			$sdac_related_content_options['outside'] = stripslashes($_POST['outside']);
			update_option('sdac_related_content_options',$sdac_related_content_options);
			$sdac_flash = "Your settings have been saved.";
		}
		if (isset($_POST['add_to_posts'])) { 
			$sdac_related_content_options['add_to_posts'] = stripslashes($_POST['add_to_posts']);
			update_option('sdac_related_content_options',$sdac_related_content_options);
			$sdac_flash = "Your settings have been saved.";
		}
		if (isset($_POST['cache_time'])) { 
			$sdac_related_content_options['cache_time'] = stripslashes($_POST['cache_time']);
			update_option('sdac_related_content_options',$sdac_related_content_options);
			$sdac_flash = "Your settings have been saved.";
		}
		if (isset($_POST['rel'])) { 
			$sdac_related_content_options['rel'] = stripslashes($_POST['rel']);
			update_option('sdac_related_content_options',$sdac_related_content_options);
			$sdac_flash = "Your settings have been saved.";
		}
		if (isset($_POST['message'])) { 
			$sdac_related_content_options['message'] = stripslashes($_POST['message']);
			update_option('sdac_related_content_options',$sdac_related_content_options);
			$sdac_flash = "Your settings have been saved.";
		}
	}
	
	if ($sdac_flash != '') echo '<div id="message"class="updated fade"><p>' . $sdac_flash . '</p></div>';

	//Defaults
		if (!$sdac_related_content_options['add_to_posts']) { $sdac_add_to_posts = 'No';} 
		else {$sdac_add_to_posts = htmlentities($sdac_related_content_options['add_to_posts']);}
		
		if (!$sdac_related_content_options['cache_time']) {$sdac_cache_time = '86400';} 
		else {$sdac_cache_time = htmlentities($sdac_related_content_options['cache_time']);}
		
		if (!$sdac_related_content_options['rel']) {$sdac_rel = 'follow';} 
		else {$sdac_rel = htmlentities($sdac_related_content_options['rel']);}
		
		if (!$sdac_related_content_options['related_title']) {$sdac_related_title = '<h4>Related Posts</h4>';} 
		else {$sdac_related_title = htmlentities($sdac_related_content_options['related_title']);}
		
		if (!$sdac_related_content_options['message']) {$sdac_message = 'No Related Posts';} 
		else {$sdac_message = htmlentities($sdac_related_content_options['message']);}
		
		if (!$sdac_related_content_options['before_list']) {$sdac_before_list = '<ul>';} 
		else {$sdac_before_list = htmlentities($sdac_related_content_options['before_list']);}
		
		if (!$sdac_related_content_options['after_list']) {$sdac_after_list = '</ul>';} 
		else {$sdac_after_list = htmlentities($sdac_related_content_options['after_list']);}
		
		if (!$sdac_related_content_options['before_item']) {$sdac_before_item = '<li>';} 
		else {$sdac_before_item = htmlentities($sdac_related_content_options['before_item']);}
		
		if (!$sdac_related_content_options['after_item']) {$sdac_after_item = '</li>';} 
		else {$sdac_after_item = htmlentities($sdac_related_content_options['after_item']);}
		
		if (!$sdac_related_content_options['inside']) {$sdac_inside = '';} 
		else {$sdac_inside = htmlentities($sdac_related_content_options['inside']);}
		
		if (!$sdac_related_content_options['outside']) {$sdac_outside = '';} 
		else {$sdac_outside = htmlentities($sdac_related_content_options['outside']);}
		
		if (!$sdac_related_content_options['type']) {$sdac_type = 'posts';} 
		else {$sdac_type = htmlentities($sdac_related_content_options['type']);}
		
		if (!$sdac_related_content_options['orderby']) {$sdac_orderby = 'post_date';} 
		else {$sdac_orderby = htmlentities($sdac_related_content_options['orderby']);}
		
		if (!$sdac_related_content_options['order']) {$sdac_order = 'DESC';} 
		else {$sdac_order = htmlentities($sdac_related_content_options['order']);}
		
		if (!$sdac_related_content_options['limit']) {$sdac_limit = '5';} 
		else {$sdac_limit = htmlentities($sdac_related_content_options['limit']);}
		
		if (!$sdac_related_content_options['echo']) {$sdac_echo = true;} 
		else {$sdac_echo = htmlentities($sdac_related_content_options['echo']);}
	
	
		if ($sdac_related_content_options['echo'] == 'true')  {$echo_output_true_checked = 'checked="checked"';} 
		else {$echo_output_false_checked = 'checked="checked"';}
	
  echo '
  	
  <div class="wrap">
  	<div style="width:650px;">
  		<h2>SDAC Related Content by Category Options</h2>
  		<p>Customize the plugin output below.</p>
  		
  		<form id="sdac_related_content_options " name="sdac_related_content_options " action="" method="post">
			
			<fieldset style="border:1px solid #aaa; margin-bottom:15px; padding:10px 10px 20px 20px; width:625px;">
				<legend style="text-transform:uppercase;font-weight:bold;">General</legend>
				
				<div style="height:40px;border-bottom:1px dashed #dedede;margin:0 5px 10px 0;">
					<div style="float:left;width:350px;margin-right:10px;">
						<label style="font-weight:bold">Number of Related Items to Show:</label>
						<h5 style="font-size:85%;margin:0;padding:0;font-weight:normal;font-style:italic;">Default: 5 Items</h5>
					</div>
					<select name="limit" style="width:240px;">
						<option value="'.$sdac_limit.'">'.$sdac_limit.'</option>
						<option value="">-------</option>
						<option value="1">1</option>
						<option value="2">2</option>
						<option value="3">3</option>
						<option value="4">4</option>
						<option value="5">5</option>
						<option value="6">6</option>
						<option value="7">7</option>
						<option value="8">8</option>
						<option value="9">9</option>
						<option value="10">10</option>
						<option value="11">11</option>
						<option value="12">12</option>
						<option value="13">13</option>
						<option value="14">14</option>
						<option value="15">15</option>
						<option value="16">16</option>
						<option value="17">17</option>
						<option value="18">18</option>
						<option value="19">19</option>
						<option value="20">20</option>
					</select>
				</div>
				<div style="height:40px;border-bottom:1px dashed #dedede;margin:0 5px 10px 0;">
					<div style="float:left;width:350px;margin-right:10px;">
						<label style="font-weight:bold">Automatically Add to Posts?:</label>
						<h5 style="font-size:85%;margin:0;padding:0;font-weight:normal;font-style:italic;">Default: No</h5>
					</div>
					<select name="add_to_posts" style="width:240px;">
						<option value="'.$sdac_add_to_posts.'">'.$sdac_add_to_posts.'</option>
						<option value="">-------</option>
						<option value="Yes">Yes</option>
						<option value="No">No</option>
					</select>
				</div>
								
				<div style="height:40px;border-bottom:1px dashed #dedede;margin:0 5px 10px 0;">
					<div style="float:left;width:350px;margin-right:10px;">
						<label style="font-weight:bold">Time to Cache Items:</label>
						<h5 style="font-size:85%;margin:0;padding:0;font-weight:normal;font-style:italic;">Default: 1 Day (86400 seconds)</h5>
					</div>
					<select name="cache_time" style="width:240px;">
						<option value="'.$sdac_cache_time.'">'.$sdac_cache_time.'</option>
						<option value="">-------</option>
						<option value="1800">30 Minutes</option>
						<option value="3600">1 Hour</option>
						<option value="7200">2 Hours</option>
						<option value="14400">4 Hours</option>
						<option value="28800">8 Hours</option>
						<option value="43200">12 Hours</option>
						<option value="86400">1 Day</option>
						<option value="172800">2 Days</option>
						<option value="259200">3 Days</option>
						<option value="604800">1 Week</option>
					</select>
				</div>
				
				<div style="height:40px;border-bottom:1px dashed #dedede;margin:0 5px 10px 0;">
					<div style="float:left;width:350px;margin-right:10px;">
						<label style="font-weight:bold">Link Relationship (Rel):</label>
						<h5 style="font-size:85%;margin:0;padding:0;font-weight:normal;font-style:italic;">Default: Follow</h5>
					</div>
					<select name="rel" style="width:240px;">
						<option value="'.$sdac_rel.'">'.$sdac_rel.'</option>
						<option value="">-------</option>
						<option value="follow">Follow</option>
						<option value="nofollow">No Follow</option>
					</select>
				</div>
				
				<div style="height:40px;border-bottom:1px dashed #dedede;margin:0 5px 10px 0;">
					<div style="float:left;width:350px;margin-right:10px;">
						<label style="font-weight:bold">Related Content Title:</label>
						<h5 style="font-size:85%;margin:0;padding:0;font-weight:normal;font-style:italic;">Default: < h4 >Related Posts < /h4 > </h5>
					</div>
					<input type="text" name="related_title" value="'.$sdac_related_title.'" style="width:240px;border:1px solid #ddd;" />
				</div>
				
				<div style="height:40px;">
					<div style="float:left;width:350px;margin-right:10px;">
						<label style="font-weight:bold">Text to Display if There Are No Matches:</label>
						<h5 style="font-size:85%;margin:0;padding:0;font-weight:normal;font-style:italic;">Default: "No Related Posts" </h5>
					</div>
					<input type="text" name="message" value="'.$sdac_message.'" style="width:240px;border:1px solid #ddd;" />
				</div>
				
			</fieldset>
			
			<fieldset style="border:1px solid #aaa; margin-bottom:15px; padding:10px 10px 20px 20px; width:625px;">
				<legend style="text-transform:uppercase;font-weight:bold;">Styling</legend>
				<div style="height:40px;border-bottom:1px dashed #dedede;margin:0 5px 10px 0;">
					<div style="float:left;width:350px;margin-right:10px;">
						<label style="font-weight:bold">Code Before Items:</label>
						<h5 style="font-size:85%;margin:0;padding:0;font-weight:normal;font-style:italic;">Default: Use the < ul > tag to put the item in an un-ordered list.</h5>
					</div>
					<input type="text" name="before_list" value="'.$sdac_before_list.'" style="width:240px;border:1px solid #ddd;" />
				</div>
				
				<div style="height:40px;border-bottom:1px dashed #dedede;margin:0 5px 10px 0;">
					<div style="float:left;width:350px;margin-right:10px;">
						<label style="font-weight:bold">Code After Items:</label>
						<h5 style="font-size:85%;margin:0;padding:0;font-weight:normal;font-style:italic;">Default: Use the < /ul > tag to close the un-ordered list.</h5>
					</div>
					<input type="text" name="after_list" value="'.$sdac_after_list.'" style="width:240px;border:1px solid #ddd;" />
				</div>
				<div style="height:40px;border-bottom:1px dashed #dedede;margin:0 5px 10px 0;">
					<div style="float:left;width:350px;margin-right:10px;">
						<label style="font-weight:bold">Code Before Link:</label>
						<h5 style="font-size:85%;margin:0;padding:0;font-weight:normal;font-style:italic;">Default: Use the < li > tag to put the item in a list.</h5>
					</div>
					<input type="text" name="before_item" value="'.$sdac_before_item.'" style="width:240px;border:1px solid #ddd;" />
				</div>
				
				<div style="height:40px;border-bottom:1px dashed #dedede;margin:0 5px 10px 0;">
					<div style="float:left;width:350px;margin-right:10px;">
						<label style="font-weight:bold">Code After Link:</label>
						<h5 style="font-size:85%;margin:0;padding:0;font-weight:normal;font-style:italic;">Default: Use the < /li > tag to close the list item.</h5>
					</div>
					<input type="text" name="after_item" value="'.$sdac_after_item.'" style="width:240px;border:1px solid #ddd;" />
				</div>
				
				<div style="height:40px;border-bottom:1px dashed #dedede;margin:0 5px 10px 0;">
					<div style="float:left;width:350px;margin-right:10px;">
						<label style="font-weight:bold">Code before_item Linked Title (within the link):</label>
						<h5 style="font-size:85%;margin:0;padding:0;font-weight:normal;font-style:italic;">Default: Nothing is set by default.</h5>
					</div>	
					<input type="text" name="inside" value="'.$sdac_inside.'" style="width:240px;border:1px solid #ddd;" />
				</div>
				
				<div style="height:40px;">
					<div style="float:left;width:350px;margin-right:10px;">
						<label style="font-weight:bold">Code after_item Linked Title (within the link):</label>
						<h5 style="font-size:85%;margin:0;padding:0;font-weight:normal;font-style:italic;">Default: Nothing is set by default.</h5>
					</div>	
					<input type="text" name="outside" value="'.$sdac_outside.'" style="width:240px;border:1px solid #ddd;" />
				</div>
			</fieldset>		
			
			<fieldset style="border:1px solid #aaa; margin-bottom:15px; padding:10px 10px 20px 20px; width:625px;">
				<legend style="text-transform:uppercase;font-weight:bold;">Content</legend>
				<div style="height:40px;border-bottom:1px dashed #dedede;margin:0 5px 10px 0;">
					<div style="float:left;width:350px;margin-right:10px;">
						<label style="font-weight:bold">Type of Related Content to Display:</label>
						<h5 style="font-size:85%;margin:0;padding:0;font-weight:normal;font-style:italic;">Default: Posts & Pages</h5>
					</div>
					<select name="type" style="width:240px;">
						<option value="'.$sdac_type.'">'.$sdac_type.'</option>
						<option value="">-------</option>
						<option value="post">Post</option>
						<option value="page">Page</option>
						<option value="">Post & Page</option>
						<option value="attachment">Attachment</option>
					</select>
				</div>
				
				<div style="height:40px;border-bottom:1px dashed #dedede;margin:0 5px 10px 0;">
					<div style="float:left;width:350px;margin-right:10px;">
						<label style="font-weight:bold">Order Related Content By:</label>
						<h5 style="font-size:85%;margin:0;padding:0;font-weight:normal;font-style:italic;">Default: Post Date (post_date)</h5>
					</div>
					<select name="orderby" style="width:240px;">
						<option value="'.$sdac_orderby.'">'.$sdac_orderby.'</option>
						<option value="">-------</option>
						<option value="post_date">Post Date</option>
						<option value="RAND">Random</option>
					</select>
				</div>
				<div style="height:40px;border-bottom:1px dashed #dedede;margin:0 5px 10px 0;">
					<div style="float:left;width:350px;margin-right:10px;">
						<label style="font-weight:bold">Order Related Content:</label>
						<h5 style="font-size:85%;margin:0;padding:0;font-weight:normal;font-style:italic;">Default: DESC</h5>
					</div>
					<select name="order" style="width:240px;">
						<option value="'.$sdac_order.'">'.$sdac_order.'</option>
						<option value="">-------</option>
						<option value="DESC">DESC (Newest to Oldest)</option>
						<option value="DESC">ASSC (Oldest to Newest)</option>
					</select>
				</div>
				<div style="height:40px;">
					<div style="float:left;width:350px;margin-right:10px;">
						<label style="font-weight:bold">Display (Echo) Items?:</label>
						<h5 style="font-size:85%;margin:0;padding:0;font-weight:normal;font-style:italic;">Default: Display (Echo)</h5>
					</div>	
					<input type="hidden" name="echo" value="true" />
					<input type="radio" name="echo" value="true" '.$echo_output_true_checked.' /> Yes
					<input type="radio" name="echo" value="false" '.$echo_output_false_checked.' /> No
				</div>
			</fieldset>
	
			<p class="submit">
				<input type="submit" name="submit_button" value="Update Related Content Options" />
			</p>
		</form>
 	</div>
  </div>
  ';	
}


add_action('admin_menu', 'sdac_related_content_menu');

function sdac_related_content_by_category($sdac_paramaters = '',  $post_id = 0) {
	global $blog_id, $wpdb, $post, $sdac_related_content_options;
	$sdac_paramaters = $sdac_related_content_options;
	$entries = array();
	$output = '';
	$related_content_expire = $sdac_related_content_options['cache_time'];
	if (!$post_id) { 
		$post_id = $post->ID;
	}
	if (!$sdac_paramaters['message']) { 
		$sdac_paramaters['message'] = 'No Related Posts';
	}
	
	$entries = wp_cache_get($post_id, "$blog_id:related_content_cached");
	if (false === $entries) {
 		$entries = $wpdb->get_results(
		sprintf(
			"SELECT DISTINCT object_id, post_title FROM {$wpdb->term_relationships} r, {$wpdb->term_taxonomy} t, {$wpdb->posts} p WHERE t.term_id IN (SELECT t.term_id FROM {$wpdb->term_relationships} r, {$wpdb->term_taxonomy} t WHERE r.term_taxonomy_id = t.term_taxonomy_id AND t.taxonomy = 'category' AND r.object_id = $post_id) AND r.term_taxonomy_id = t.term_taxonomy_id AND p.post_status = 'publish' AND p.ID = r.object_id AND object_id <> $post_id %s %s %s",
			(isset($sdac_paramaters['type']) === true && empty($sdac_paramaters['type']) === false) ? ("AND p.post_type = '" .$sdac_paramaters['type']. "'") : '',
			(isset($sdac_paramaters['orderby']) === true && empty($sdac_paramaters['orderby']) === false) ? ('ORDER BY ' .(strtoupper($sdac_paramaters['orderby']) == 'RAND' ? 'RAND()' : $sdac_paramaters['orderby']. ' ' .(isset($sdac_paramaters['order']) ? $sdac_paramaters['order'] : ''))) : '',
			(isset($sdac_paramaters['limit']) === true && empty($sdac_paramaters['limit']) === false) ? ('LIMIT ' .$sdac_paramaters['limit']) : ''
		),
		OBJECT
		);
    	wp_cache_set($post_id, $entries, "$blog_id:related_content_cached", $related_content_expire);
    } 	
	
	if ($entries) { 
		$output .= $sdac_paramaters['related_title'] . $sdac_paramaters['before_list']. "\n";
		foreach ($entries as $entry) {
			$output .=  $sdac_paramaters['before_item'] . '<a href="'.get_permalink($entry->object_id).'" rel="'.$sdac_paramaters['rel'].'" title="'.$entry->post_title.'">' .$sdac_paramaters['inside'] .$entry->post_title .$sdac_paramaters['outside'].'</a>' .$sdac_paramaters['after_item']. "\n";
		}
		$output .=  $sdac_paramaters['after_list']. "\n";
	} else {
		$output = $sdac_paramaters['message'];
	}
	if (isset($sdac_paramaters['echo']) === true && $sdac_paramaters['echo']) {
		return $output;
	} else {
		return $output;
	}
}

function sdac_related_content() {
	global $post;
	$related_content = sdac_related_content_by_category();
	return $related_content;
}

function sdac_add_related_content($content) {
	if ((is_page() && $sdac_related_content_options['add_to_posts'] != 'No') || (!is_page() && $sdac_related_content_options['add_to_pages'] != 'No')) {
		if (!is_single()) {
			$content = $content;
		} else {
			$content .= "<p>".sdac_related_content()."</p>";
		}
	
	}		
	return $content;
}

function sdac_remove_related_content($content) {
	remove_action('the_content', 'sdac_add_related_content');
	return $content;
}

if ($sdac_related_content_options['add_to_posts'] != 'No' || $sdac_related_content_options['add_to_pages'] != 'No') {
	add_filter('the_content', 'sdac_add_related_content');
	add_filter('the_excerpt', 'sdac_add_related_content');
	add_filter('get_the_excerpt', 'sdac_remove_related_content',9);
}

?>
